﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private serial As Serial
	Private admin As BluetoothAdmin
	Private ast As AsyncStreamsText
	Public connected As Boolean
	Public connecting As Boolean

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	serial.Initialize("serial")
	admin.Initialize("admin")

End Sub

Public Sub Connect
	admin.StartDiscovery
	connecting = True
	CallSub(Main, "SetState")
End Sub

Private Sub admin_DeviceFound (Name As String, MacAddress As String)
	Log($"Device found: ${MacAddress} ${Name}"$)
	If Name = "HC-06" Then
		Log("Trying to connect...")
		admin.CancelDiscovery
		serial.Connect(MacAddress)
	End If
End Sub

Private Sub admin_DiscoveryFinished
	connecting = False
End Sub

Private Sub Serial_Connected (Success As Boolean)
	If Success Then
		If ast.IsInitialized Then ast.Close
		ast.Initialize(Me, "Ast", serial.InputStream, serial.OutputStream)
		Log("Connected")
		connected = True
	Else
		Log(LastException)
	End If
	connecting = False
	CallSub(Main, "SetState")
End Sub

'Public Sub SendMessage(msg() As Byte)
'	ast.astreams.Write(msg) 'sending bytes, not text
'End Sub

Public Sub SendMessage(msg As String)
'	ast.astreams.Write(msg.GetBytes("UTF8"))
	ast.Write(msg)
End Sub

Private Sub ast_NewText (Text As String)
	CallSub2(Main, "MessageFromDevice", Text)
End Sub

Private Sub ast_Terminated
	connected = False
	CallSub(Main, "SetState")
End Sub
Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub


Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	'Return true to allow the OS default exceptions handler to handle the uncaught exception.
	Return True
End Sub

Sub Service_Destroy

End Sub
